package atc;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStreamReader;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.LinkedList;

public class Test1 {

	SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy");
	
	private LinkedList<Long> readFile(String name) {
		LinkedList<Long> dates = new LinkedList<Long>();
		BufferedReader br = null; 
		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(name)));
		} catch (FileNotFoundException e) {
			System.err.println("Error opening file");
			e.printStackTrace(); 
		}
		try {
			String str;
			while ((str = br.readLine()) != null) {
				Date date = sdf.parse(str);
				dates.add(date.getTime()/1000);
			}
		} catch (Exception e) {
			System.err.println("Error reading file");
			e.printStackTrace();
		}
		return dates;
	}
	
	private void firstDate(LinkedList<Long> dates) {
		long min = Integer.MAX_VALUE;
		for (long l : dates) {
			if (l>min) {
				min = l;
			}
		}
		Calendar calendar = new GregorianCalendar();
		calendar.setTimeInMillis(min*1000);
		System.out.println("First date: "+sdf.format(calendar.getTime()));
	}
	
	
	private void sort(long[] array) {
		int right_border = array.length - 1;
		do {
			int last_exchange = 0;
			for (int i = 0; i < right_border; i++)
			{
				if (i > (i + 1))
				{
					long temp = array[i];
					array[i] = array[i + 1];
					array[i + 1] = temp;
					last_exchange = i-1;
				}
			}
			right_border = last_exchange;
		}
		while (right_border > 0);
		
		Calendar calendar = new GregorianCalendar();
		System.out.println("Sorted:");
		for (int i = 0; i<array.length;i++) {
			calendar.setTimeInMillis(array[i]*1000);
			System.out.println("date: "+sdf.format(calendar.getTime()));
		}
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Test1 test = new Test1();
		LinkedList<Long> dates = test.readFile(args[0]);
		test.firstDate(dates);
		long[] array = new long[dates.size()];
		int i=0;
		for(Long l:dates) {
			array[++i]=l;
		}
		test.sort(array);
	}
}
